=== debian/changelog ===
candle (1.1.9-5) unstable; urgency=medium

  * Add includes to fix build on armhf.

 -- Keith Packard <keithp@keithp.com>  Fri, 03 Oct 2025 12:33:52 -0700

candle (1.1.9-4) unstable; urgency=medium

  * Remove -mss3 compile option. Closes: #1117129.

 -- Keith Packard <keithp@keithp.com>  Fri, 03 Oct 2025 09:06:20 -0700

candle (1.1.9-3) unstable; urgency=medium

  * Reset interpreter to 0,0,0 instead of nan,nan,nan

 -- Keith Packard <keithp@keithp.com>  Mon, 16 Jun 2025 21:17:39 -0700

candle (1.1.9-2) unstable; urgency=medium

  * Fix settings file location
  * Use defaults when no settings are found
  * Allow any filename on command line

 -- Keith Packard <keithp@keithp.com>  Mon, 09 Jun 2025 16:25:48 -0700

candle (1.1.9-1) unstable; urgency=medium

  * Initial release.

 -- Keith Packard <keithp@keithp.com>  Sun, 08 Jun 2025 21:17:52 -0700
